#include "modc.h"

//Datei zur Effektberechnung
void dovoicehigher(void){
/*DS:DI-->Voice
* Cl:Steps
 RETURN: CX:NewVoice*/
asm("
 #Das folgende berechnet CX:=DS:[DI]*2^(-cx/12)
     xorb %ch,%ch
     movw $0xf1a2,%bx #halfnote
     movw $0xffff,%ax
vh1: mulw %bx
     movw %dx,%ax
     aword;loop vh1
     movw (%edi),%cx
     mulw %cx
     cmpw $133,%dx
     ja  vh2
     movw $134,%dx
vh2:
     movw %dx,%cx
");
}

void dovoicelower(void){
/*DS:DI-->Voice
 Cl:Steps
 RETURN: CX:NewVoice*/
asm("
 #Das folgende berechnet CX:=DS:[DI]*2^(cx/12)
     andl $0xff,%ecx
     mov  $0x10f39,%ebx #halfnote1
     xor %eax,%eax
     decw %ax
vl1: mul %ebx
     shr $16,%eax
     shl $16,%edx
     add %edx,%eax
     aword;loop vl1
     movw (%edi),%cx
     mul %ecx
     cmp $0,%dx
     je vl2
     movw $54784,%cx
     jmp vlexit
vl2:
     shr $16,%eax
     movw %ax,%cx
vlexit:
");
}

void checkrange(void){
asm("
   cmp $1,forcerange
   jne  crout
   cmpw $3616-1,%cx
   ja  cr2
   movw $3616,%cx
   jmp crout
cr2:
   cmpw $27392+1,%cx
   jb  crout
   movw $27392,%cx
crout:
");
}

void testrange(void){
asm("
   cmp $1,forcerange
   jne  trout
   cmpw $3616-1,%cx
   ja  tr2
   stc
   jmp trout1
tr2:
   cmpw $27392+1,%cx
   jb  trout
   stc
   jmp trout1
trout:
   clc
trout1:
");
}

void dophiplo(word Note,void *oPlo,word FineTune){
#if 0
  int tmp;
  //Note=hiword(tunetable[instruments[Inst].finetune]*Note);
/* Phi,Plo sind hintereinander abgelegt (2 Words) erst Plo dann Phi */ 
  tmp=word((tunetable[FineTune & 0x000f]*(int32)Note)>>16);
  *((unsigned int*)oPlo)=(65536*notestretch) / tmp;

/*notestretch=Cx*CxTuning/Samplefreq
  ...Cx = Note fr Mittlere Oktave (normal: C2, S3M: C4)
  ...CxTuning = Samplefrequenz fr Cx */

#else
asm("
  xor %ecx,%ecx
  movw 8(%ebp),%cx #note
  xor %ebx,%ebx
  movw 16(%ebp),%bx #finetune
  andw $0x000f,%bx
  orb %bl,%bl
  je dpp0
  shlw $4,%bx #shlw $2,%bx
  add $tunetable,%ebx
  mov (%ebx),%eax
  mul %ecx
  mov %eax,%ecx
  shr $16,%ecx
dpp0:
  cmpw $133,%cx
  ja dpp1
  movw $134,%cx
dpp1:
  xor %edx,%edx
  xor %eax,%eax
  mov notestretch,%eax
  div %ecx
  mov 12(%ebp),%edi #Pointer zu Phi,Plo
  mov %eax,(%edi)
");
#endif
}

/**********************************ARPEGGIO***********************************/
void doarpeggio(byte ops,void *oAcnt,void *oTon,void *oPLo, word FineTune){
#ifndef USE_ASM
byte &acnt= *((byte*) oAcnt);
word &note= *((word*) oTon);
  if (!ops) return;
  acnt++;
  if (acnt>=3) acnt=2;
  note=ops>>(acnt<<2) & 0x000f;
  //dovoicehigher();
  dophiplo(note,oPLo,FineTune);  
#else
asm("
          cmpb $0,8(%ebp)		#ops
          je  apgnextappr
          #Fuer weiter unten DS:DI auf TON stezen
          mov 16(%ebp),%edi		#oton
          movw (%edi),%cx
          call testrange__Fv
          jc apgnextappr
          #Nchsten Halbtonschritt holen INC(ACNT MOD 3)
          mov 12(%ebp),%esi	#oAcnt
          movb (%esi),%cl
          decb %cl
          cmpb $3,%cl
          jb  apgappra
          movb $2,%cl
apgappra:   movb %cl,(%esi)     #in acnt steht der Halbtonschritt (0,1,2)
          #Operands laden (0,x,y)
          xorw %bx,%bx
          movb 8(%ebp),%bl		#ops
          shlb $2,%cl
          shrb %cl,%bl
          movb %bl,%cl
          and $0x00f,%cx       #In cx steht die Anzahl der Halbtonschritte zu Schritt 0
          #Wenn Originalnote-->keine Berechnung der Halbtonschritte
          jcxz apgapprc
          call dovoicehigher__Fv
          jmp apgapprd
          #In cx neue Tonhhe
apgapprc: movw (%edi),%cx
apgapprd: pushl 24(%ebp)		#Finetune
          pushl 20(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
          call dophiplo__FUsPvUs
apgnextappr:
");
#endif
}

/******************************OKTaARPEGGIO*Up*Down***************************/
void doarpeggio1(byte ops,void *oAcnt,void *oTon,void *oPLo,word FineTune){
asm("
          cmpb $0,8(%ebp)	#ops
          je  arp1nextappr
          #Fuer weiter unten DS:DI auf TON stezen
          mov 16(%ebp),%edi	#oton
          movw (%edi),%cx
          call testrange__Fv
          jc arp1nextappr
          #Naechsten Halbtonschritt holen INC(ACNT MOD 3)
          mov 12(%ebp),%esi	#oAcnt
          movb (%esi),%cl
          decb %cl
          cmpb $4,%cl
          jb  arp1appra
          xorb %cl,%cl
arp1appra:   movb %cl,(%esi)     #in acnt steht der Halbtonschritt (0,1,2,3)
          #Operands laden (0,x,y)
          cmpb $1,%cl
          je  arp1apprc
          cmpb $3,%cl
          je  arp1apprc
          cmpb $0,%cl
          jne arp1apprb
          movb 8(%ebp),%cl		#ops
          shrb $4,%cl
          call dovoicehigher__Fv
          jmp arp1apprd
arp1apprb:   movb 8(%ebp),%cl		#ops
          andb $0x0f,%cl
          call dovoicelower__Fv
          jmp arp1apprd
          #In cx neue Tonhhe
arp1apprc:   movw (%edi),%cx
arp1apprd: 
	  pushl 24(%ebp)		#Finetune
          pushl 20(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
	  call dophiplo__FUsPvUs
arp1nextappr:
");
}
/******************************OKTaARPEGGIO*Down*UP****************************/
void doarpeggio2(byte ops,void *oAcnt,void *oTon,void *oPLo,word FineTune){
asm("
          cmpb $0,8(%ebp)	#ops
          je  arp2nextappr
          #Fuer weiter unten DS:DI auf TON stezen
          mov 16(%ebp),%edi		#oton
          movw (%edi),%cx
          call testrange__Fv
          jc arp2nextappr
          #Nchsten H%albtonschritt holen INC(ACNT MOD 3)
          mov 12(%ebp),%esi		#oacnt
          movb (%esi),%cl
          decb %cl 
	  cmpb $4,%cl
          jb  arp2appra
          xorb %cl,%cl
arp2appra:   movb %cl,(%esi)     #in acnt steht der H%albtonschritt (0,1,2,3)
          #Operands laden (0,x,y)
          cmpb $1,%cl
          je  arp2apprc
          cmpb $3,%cl
          je  arp2apprc
          cmpb $0,%cl
          jne arp2apprb
          movb 8(%ebp),%cl		#ops
          shrb $4,%cl
          call dovoicelower__Fv
          jmp arp2apprd
arp2apprb:   movb 8(%ebp),%cl		#ops
          andb $0x0f,%cl
          call dovoicehigher__Fv
          jmp arp2apprd
          #In %cx neue Tonhhe
arp2apprc: movw (%edi),%cx
arp2apprd: pushl 24(%ebp)		#Finetune
          pushl 20(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
	  call dophiplo__FUsPvUs
arp2nextappr:
");
}

/********************************PORTAMENTO UP*********************************/
void doportamento_up(byte Ops,void *oTon,void *oPLo,word FineTune){

#ifndef USE_ASM
word &Note = *((word*)oTon);
  Note+=(32*(speed-1)/speed)*Ops*(currvblanc+1);
  dophiplo(Note,oPLo,FineTune);
#else 
asm("
          mov 12(%ebp),%edi		#oton
          movw (%edi),%cx
          call testrange__Fv
          jc  punextpu
          cmpb $0,8(%ebp)		#ops
          je punextpu
          #OriginalTon um (32*(Speed-1)/speed)*Operands*(Takt+1) Einheiten erhhen
          xor %eax,%eax
          xor %edx,%edx
          xor %ebx,%ebx
          #(Speed-1)*32...
          movb speed,%al
          decb %al
          movb $32,%bl
          mulb %bl
          #...*Operands
          movb 8(%ebp),%bl		#ops
          mul %ebx
          #...*(Takt+1)
          movb currvblanc,%bl
          incb %bl
          mul %ebx
          #.../Speed
          movb speed,%bl
          div %ebx
          #berlauf-Prfung
          mov %eax,%edx
          shr $16,%edx
          cmpw 0,%dx
          je  pu0
          movw $134,%cx
          jmp pu2
pu0:      movw (%edi),%cx
          cmpw %ax,%cx
          ja  pu1
          movw $134,%cx
          jmp pu2
pu1:       subw %ax,%cx
pu2:       call checkrange__Fv
          movb currvblanc,%dl #Am Ende einer Notenzeile erreichten Ton merken!
          incb %dl
          cmpb speed,%dl
          jne pupub
          movw %cx,(%edi)
pupub:     
	  #Umrechnung der Tonhhe in Phi,Plo
          pushl 20(%ebp)		#Finetune
          pushl 16(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
          call dophiplo__FUsPvUs
punextpu:
");
#endif
}

/********************************PORTAMENTO DOWN*******************************/
void doportamento_down(byte Ops,void *oTon,void *oPLo,word FineTune){
#ifndef USE_ASM
word &Note = *((word*)oTon);
  Note-=(32*(speed-1)/speed)*Ops*(currvblanc+1);
  dophiplo(Note,oPLo,FineTune);
#else 
asm("
          mov 12(%ebp),%edi		#oton
          movw (%edi),%cx
          call testrange__Fv
          jc  pdnextpd
          cmpb $0,8(%ebp)		#ops
          je pdnextpd
          #OriginalTon um (32*(Speed-1)/speed)*Operands*(Takt+1) Einheiten verringern
           xor %eax,%eax
           xor %edx,%edx
           xor %ebx,%ebx
          #(Speed-1)*32...
          movb speed,%al
          decb %al
          movb $32,%bl
          mulb %bl
          #...*Operands
          movb 8(%ebp),%bl		#ops
          mul %ebx
          #...*(Takt+1)
          movb currvblanc,%bl
          incb %bl
          mul %ebx
          #.../Speed
          mov speed,%bl
           div %ebx
          #berlauf-Prfung
           mov %eax,%edx
          shr $16,%edx
          cmp $0,%dx
          je  pd0
          movw $54784,%cx
          jmp pd1
pd0:       movw (%edi),%cx
          addw %ax,%cx
          #berlauf-Prfung
          jnc pd1
          movw $54784,%cx
pd1:       call checkrange__Fv
          movb currvblanc,%dl #Am Ende einer Notenzeile erreichten Ton merken!
          incb %dl
          cmpb speed,%dl
          jne pdpdb
          movw %cx,(%edi)
pdpdb:     #Umrechnung der Tonhhe in Phi,Plo
          pushl 20(%ebp)		#Finetune
          pushl 16(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
          call dophiplo__FUsPvUs
pdnextpd:
");
#endif
}

/********************************Tone PORTAMENTO*******************************/
void dotone_portamento(byte Ops,void *oTon,void *oTpTon,void *oPLo,word FineTune){
asm("
          #[DI]-->TON; [SI]-->Zu erreichender Ton
          cmpb $0,8(%ebp)	#ops
          je tpnexttp
          mov 12(%ebp),%edi	#oton
          movw (%edi),%cx
          call testrange__Fv
          jc  tpnexttp
          mov 16(%ebp),%esi	#otpton
          cmpw $0,(%esi)
          je  tpnexttp
          movw (%esi),%cx
          cmpw (%edi),%cx
          je  tpnexttp
          #Glissando oder normal?
          cmpb $0,glissandoon
          je tpNoGliss
          #Glissando...
          movw (%edi),%cx
          cmpw (%esi),%cx     #Ton hher oder tiefer?
          jb  tpgld
          #hher
          movb 8(%ebp),%cl	#ops
          call dovoicehigher__Fv
          cmpw (%esi),%cx     #END-Tonhhe erreicht?
          jae tpglu1
          movw %cx,(%esi)     #END-Tonhhe erreicht!!
tpglu1:    call checkrange__Fv
          movw %cx,(%edi)
          jmp tptpb
tpgld:     #tiefer
          movb 8(%ebp),%cl  	#ops
          call dovoicelower__Fv
          cmpw (%esi),%cx     #END-Tonhhe erreicht?
          jbe tpgld1
          movw (%esi),%cx     #END-Tonhhe erreicht!!
tpgld1:    call checkrange__Fv
          movw %cx,(%edi)
          jmp tptpb
tpNoGliss: #Normales Portamento...
          #OriginalTon um 32*(Speed-1)*Operands*(Takt+1)/speed Einheiten erhhen oder verringern
          xor %eax,%eax
          xor %edx,%edx
          xor %ebx,%ebx
          #(Speed-1)*32...
          movb speed,%al
          decb %al
          movb $32,%bl
          mulb %bl
          #...*Operands
          movb 8(%ebp),%bl	#ops
          mul %ebx
          #...*(Takt+1)
          movb currvblanc,%bl
          incb %bl
          mul %ebx
          #.../Speed
          movb speed,%bl
          div %ebx
          #berlauf-Prfung
          mov %eax,%edx
          shr $16,%edx
          cmpw $0,%dx
          je  tp0
          movw (%esi),%cx
          jmp tptpa
tp0:       movw (%esi),%dx
          movw (%edi),%cx
          cmpw %dx,%cx      #Ton erhhen oder verringern?
          jb  tptpua
          #verringern!
          #berlauf-Prfung
          cmpw %ax,%cx
          ja  tp1
          movw %dx,%cx
          jmp tptpda
tp1:       subw %ax,%cx
          cmpw %dx,%cx      #END-Tonhhe erreicht?
          jae tptpda
          movw %dx,%cx      #END-Tonhhe erreicht!!
tptpda:    call checkrange__Fv
          jmp tptpa
tptpua:    #erhhen!
          addw %ax,%cx
          #berlauf-Prfung
          jnc tpcmpu
          movw %dx,%cx
          jmp tptpub
tpcmpu:    cmpw %dx,%cx      #END-Tonhhe erreicht?
          jbe tptpub
          movw %dx,%cx      #END-Tonhhe erreicht!!
tptpub:    call checkrange__Fv
tptpa:     movb currvblanc,%dl #Am Ende einer Notenzeile erreichten Ton merken!
          incb %dl
          cmpb speed,%dl
          jne tptpb
          movw %cx,(%edi)
tptpb:     #Umrechnung der Tonhhe in Phi,Plo
          pushl 24(%ebp)		#Finetune
          pushl 20(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
          call dophiplo__FUsPvUs
tpnexttp:
");
}
int32 scale = 1522;
int32 scale1 = 1592;
void adjustfrequencyup(word& Toneh,byte ops){
asm("
          xor %edx, %edx    # EDX := 0 
          xor %eax, %eax
          dec  %eax       # EAX := $FFFFFFFF 
          xor %ebx, %ebx
          mov  8(%ebp), %edi #Toneh
          mov  (%edi), %bx
          div  %ebx       # EAX := EDX:EAX div Toneh 
          mov  %eax,%ebx
          xor  %eax,%eax
          mov  12(%ebp), %al	#ops
          movw scale,%ecx
          cmp $f669,filetype
          jne afu0
          movw scale1,%ecx
          addb %al,%al
          decb %al
  afu0:     imul  %ecx ,%eax
          add  %eax,%ebx    # new Toneh := Toneh + const * Ops 
          jnc afu1
          movw $134,%ax
          movw %ax,(%edi)
          jmp afuExit
  afu1:     xor %edx, %edx    # EDX := 0 
          xor %eax, %eax
          dec  %eax       # EAX := $FFFFFFFF 
          div  %ebx       # EAX := EDX:EAX div new Toneh 
          movw %ax,(%edi)
          rol  $16, %eax
          orw  %ax, %ax
          jz  afuExit
          movw  $54784,%ax
          movw %ax,(%edi)
  afuExit:
");
}

void adjustfrequencydown(word& Toneh,byte Ops){
asm("
          xor %edx, %edx    # EDX := 0 
          xor %eax, %eax
          dec  %eax       # EAX := $FFFFFFFF 
          xor %ebx, %ebx
          mov  8(%ebp), %edi	#toneh
          movw  (%edi), %bx
          div  %ebx       # EAX := EDX:EAX div Toneh 
          mov  %eax,%ebx
          xor %eax, %eax
          movb  12(%ebp), %al	#ops
          mov  scale,%ecx
          cmp $f669,filetype
          jne afd0
          movw scale1,%ecx
          addb %al,%al
          decb %al
  afd0:     imul  %ecx ,%eax
          cmp %eax,%ebx
          jbe afd2Big
          sub %eax,%ebx    # new Toneh := Toneh - const * Ops 
          xor %edx,%edx    # EDX := 0 
          xor %eax, %eax
          dec  %eax       # EAX := $FFFFFFFF 
          div  %ebx       # EAX := EDX:EAX div new Toneh 
          movw %ax,(%edi)
          rol  $16,%eax
          cmpw  $0, %ax
          jz  afdExit
  afd2Big:  movw  $54784,%ax
          movw %ax,(%edi)
  afdExit:
");
}

/***********************************Vibrato************************************/
void dovibrato(byte ops,void *oTon,void *oVTini,void *oPLo,word FineTune){
asm("
          mov 12(%ebp),%edi	#oton
          movw (%edi),%cx
          call testrange__Fv
          jc  lvinextv
          #DS:DI-->VTini
          mov 16(%ebp),%edi	#oVtini
          #Berechnen des Zeigers auf die Sinustable
          #Operands=XY Hex
          #OldPointer+(20*(VBlanc+1)*X)/6
          xorb %ah,%ah
          movb $20,%al
          xorb %bh,%bh
          movb currvblanc,%bl
          incb %bl
          mulw %bx
          movb 8(%ebp),%bl	#ops
          shrb $4,%bl
          mulw %bx
          #berlauf-Prfung
          cmpw $0,%dx
          je  lvi0
          mov 12(%ebp),%edi	#oton
          movw (%edi),%cx
          jmp lvicheck
lvi0:     movb $6,%bl
          divw %bx
          addb (%edi),%al
          movb currvblanc,%bl
          incb %bl
          cmpb speed,%bl
          jne lvivibc
          xor %eax,%eax
          movb %al,(%edi)
lvivibc:    xorb %ah,%ah   #in AL steht der Zeiger auf die Tabelle
          #DS:SI-->Tabelle
          mov vtable,%esi
          add %eax,%esi
          movb (%esi),%al #in AL steht der Wert aus der Sinustabelle
          #Berechnen von 32*4*Y*table^+Ton
          movb 8(%ebp),%bl	#ops
          andb $0x0f,%bl
          imulb %bl
          movb %ah,%al
          cbw
          movw $128,%cx
          imulw %cx
          #DS:SI-->Ton
          mov 12(%ebp),%esi	#oton
          movw (%esi),%cx
          #FehlerCheck
          cmpw $32767,%ax
          ja  lvidown
          addw %ax,%cx
          jnc lvicheck
          movw $54784,%cx
          jmp lvicheck
lvidown:    negw %ax
          cmpw %cx,%ax
          ja  lvi1
          subw %ax,%cx
          jmp lvicheck
lvi1:       movw $134,%cx
          #Definitionsbereich berprfen 3616-27392 sind valid
lvicheck:   call checkrange__Fv
          #Umrechnung der Tonhhe in Phi,Plo
          pushl 24(%ebp)		#Finetune
          pushl 20(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
          call dophiplo__FUsPvUs
lvinextv:
");
}

/**********************************Tremolo************************************/
void dotremolo(byte Ops,void *oVolume,void *oVolsld,void *oVTini){
asm("
          #DS:DI-->VTini
          mov 20(%ebp),%edi	#oVtini
          #Berechnung des Zeigers auf die Sinustabelle (Start bei pi/4==64!!!)
          xorb %ah,%ah
          movb $20,%al
          xorb %bh,%bh
          movb currvblanc,%bl
          incb %bl
          mulw %bx
          movb %bl,8(%ebp)	#ops
          shrb $4,%bl
          mulw %bx
          movb $6,%bl
          divw %bx
          addb (%edi),%al
          movb currvblanc,%bl
          incb %bl
          cmpb speed,%bl
          jne ltrec
          xor %eax,%eax
          movb %al,(%edi)
ltrec:    xorb %ah,%ah               #in AL steht der Zeiger auf die Sinustabelle
          mov $ttable,%esi
          add %eax,%esi
          movb (%esi),%al #in AL steht der Wert aus der Sinustabelle
          #Berechnung von 4*Y*table^+Volume1
          movb 8(%ebp),%bl	#ops
          andb $0x0f,%bl
          imulb %bl
          movb %ah,%al
          movb $4,%cl
          imulb %cl
          xorb %ch,%ch
          #DS:SI-->VolSld
          mov 16(%ebp),%esi	#oVolsld
          movb (%esi),%cl
          addw %ax,%cx               #in CX steht die neue Lautstrke
          cmpb $0,%ch                #Definitionsbereich berprfen...
          je  ltrea
          xorw %cx,%cx
          jmp ltreb
ltrea:    cmpw $65,%cx
          jb  ltreb
          movw $64,%cx
ltreb:    mov 12(%ebp),%edi	#oVolume
          movb %cl,(%edi)          #Lautstrke setzen
");
}

/***********************************VolumeSlide********************************/
void dovolumeslide(byte Ops,void *oVolume,void *oVolSld){
asm("
          xor %edx,%edx
          xor %eax,%eax
          xor %ebx,%ebx
          #DS:DI-->VolSld
          mov 16(%ebp),%edi	#ovolsld
          #DS:SI-->Volume
          mov 12(%ebp),%esi	#ovolume
          #Lautstrke um (X oder Y)*(Takt+1)*(Speed-1)/Speed Einheiten erhhen oder verringern
          movb 8(%ebp),%al	#ops
          cmpb $10,%al
          jb  vsva
          #Erhhen!...
          shrb $4,%al
          #...*(Takt+1)
          movb currvblanc,%bl
          incb %bl
          mulw %bx
          #*(Speed-1)/Speed
          movb speed,%bl
          decb %bl
          mul %ebx
          incb %bl
          div %ebx
          movb (%edi),%bl
          addw %ax,%bx
          cmpw $41,%bx #Definitionsbereich prfen
          jb  vsvb
          movw $40,%bx
          jmp vsvb
          #Verringern!...
vsva:      andb $0x0f,%al
          #...*(Takt+1)
          movb currvblanc,%bl
          incb %bl
          mulw %bx
          #*(Speed-1)/Speed
          movb speed,%bl
          decb %bl
          mul %ebx
          incb %bl
          div %ebx
          movb (%edi),%bl
          cmpw %ax,%bx
          ja vs1
          movw $0,%bx
          jmp vsvb
vs1:       subw %ax,%bx
vsvb:      movb %bl,(%esi)
          #Am Ende einer Notenzeile erreichte Lautstrke merken!
          movb currvblanc,%dl
          incb %dl
          cmpb speed,%dl
          jne vsvc
          movb %bl,(%edi)
vsvc:
");
}

void dooktsldup(byte Ops,void *oTon,void *oPLo,word FineTune){
asm("
          mov 12(%ebp),%edi		#oton
          movw (%edi),%cx
          call testrange__Fv
          jc  osluout
          movb 8(%ebp),%cl		#ops
          call dovoicehigher__Fv
          call checkrange__Fv
          movw %cx,(%edi)
          pushl 20(%ebp)		#Finetune
          pushl 16(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
          call dophiplo__FUsPvUs
osluout:
");
}

void dooktslddwn(byte Ops,void *oTon,void *oPLo,word FineTune){
asm("
          mov 12(%ebp),%edi	#oton
          movw (%edi),%cx
          call testrange__Fv
          jc  osldout
          movb 8(%ebp),%cl	#ops
          call dovoicelower__Fv
          call checkrange__Fv
          movw %cx,(%edi)
          pushl 20(%ebp)		#Finetune
          pushl 16(%ebp)		#oPlo
	  andl $0x0000ffff,%ecx
 	  pushl %ecx
          call dophiplo__FUsPvUs
osldout:
");
}

void doplayoffset(tchannel& Chn){
asm("
  mov 8(%ebp),%edi	#Adresse des ubergebenen Kanals
  xor %eax,%eax
  mov tch.opnd(%edi),%ah
  add (%edi),%eax
  cmp tch.iend(%edi),%eax
  jb po1
  mov tch.lend(%edi),%eax
  mov %eax,tch.iend(%edi)
  mov tch.lst(%edi),%eax
po1:
  mov %eax,(%edi)
");
}

//boolean forcebpm=false;
void dosetspeed(byte Ops){

asm("
          xorb %ch,%ch
          movb 8(%ebp),%cl	#ops
          orw %cx,%cx
          jnz sp0
          cmp $unis,filetype
          jne sp01
          #UNIS-Speed 0
          movb initbpmspeed,%cl
          movw $3,%ax
          mulb %cl
          movb %al,%cl
          movb  $1,speed
          jmp spsetBPM
sp01:      incw %cx
sp0:       cmpb $0,forcebpm
          jne spsetBPM
          cmp $unis,filetype
          je  spNoBPM
          cmp $f669,filetype
          je  spNoBPM
          cmp $s3m,filetype
          je  spsetvblanc
          cmp $0,soundsettings+nobpm
          jne spNoBPM
          cmpb $0x1f,%cl
          jna  spsetvblanc
spsetBPM:  #BPMSpeed:=Ops
          cmpb $12,%cl
          ja  sp1
          movb $13,%cl
sp1:       movb %cl,bpmspeed
          #TimeStep:=$9C40000 DIV BPMSpeed
          xorw %dx,%dx
          movw $0x9C4,%ax
          divw %cx
          movw %ax,timestep+2
          xorw %ax,%ax
          divw %cx
          movw %ax,timestep
          #NumSamples:=trunc(2.5*soundsettings.samplerate/BPMSpeed)
          movw soundsettings+samplerate,%ax
          xorw %dx,%dx
          #BX:=AX/2
          movw %ax,%bx
          shrw $1,%bx
          #DX,AX:=DX,AX*2
          shlw $1,%ax
          rclw $1,%dx
          #DX,AX:=DX,AX+BX
          addw %bx,%ax
          jnc spnoadd
          incw %dx
spnoadd:   #AX:=DX,AX/BPM-Speed
          divw %cx
          movw %ax,numsamples
          jmp spexit
spNoBPM:   jcxz spexit
          movb %cl,speed
          movb initbpmspeed,%cl
          jmp spsetBPM
spsetvblanc:
          jcxz spexit
          movb %cl,speed
spexit:
");
}

/*
*  New_BPM   128/speed + x   128 + x * speed
*  ------- = ------------- = ---------------
*  Old_BPM     128/speed           128
*/

int32 farbpmspeed;

void dofinefartempo(char Spd)
{
  if (Spd==0) farbpmspeed=128*80;
    else farbpmspeed=farbpmspeed*(128+speed*Spd)/ 128;
  if (farbpmspeed>128*255) farbpmspeed=128*255;
  forcebpm=true;
  dosetspeed(farbpmspeed >> 7);
  forcebpm=false;
}
