#include "modc.h"
#include "oktalyzer.h"
#include <fstream.h>

word pattlen;
toktnote notearray[2048];
typedef pnotearray *notearray;

//******************************oktalyzer****************************************************
void okt_getfiledata(void){
  for( i=0; i<= numpatterns-1;i++)
    for( j=1; j<= numtracks;j++) (*tracks)[i][j]=numtracks*parrangement[i]+j;
  pbuffer=malloc(65520);if ( pbuffer==NULL ) { error=id_nomem;return;}
  f.seekg(filepos(f)-8);
  for( i=0; i<= lastpattern ;i++)
  {
    f.read(pbuffer,sizeof(toktsign));
    poktsign(pbuffer)->structsize=swaplong(poktsign(pbuffer)->structsize);
    if ( poktsign(pbuffer)->b4sign=='pbod' )
    {
      f.read(&pattlen,2);
      pattlen=swap(pattlen);
      bufsize=poktsign(pbuffer)->structsize-2;
      f.read(pbuffer,bufsize);
      if ( f.gcount()!=bufsize ) { error=id_nomodfile;free(pbuffer);exit;}
      if ( alreadyplayed[i] )
      {
        for( j=0 ;j<= numpatterns-1;j++ )
	  if ( parrangement[j]==i ) ptrnbreaks[j]=pattlen-1;
       //auswertung der pattern-daten
        for( k=1 ;k<= numtracks;k++)
        {
          memset(pattern,0,sizeof(ttrack));
          reached=false;
          for( j=0; j<=(pattlen-1);j++)
	    //with pattern^[1][j],pnotearray(pbuffer)^[j*numtracks+k] do
          {
	    byte& instrument=(*pattern)[1][j].instrument;
	    word& ton=(*pattern)[1][j].ton;
	    byte& effekt=(*pattern)[1][j].effekt;
	    byte& operands=(*pattern)[1][j].operands;
	    char& chnvol=(*pattern)[1][j].chnvol;
	    byte& byte1=(*pnotearray(pbuffer))[j*numtracks+k].byte1;
	    byte& byte2=(*pnotearray(pbuffer))[j*numtracks+k].byte2;
	    byte& byte3=(*pnotearray(pbuffer))[j*numtracks+k].byte3;
	    byte& byte4=(*pnotearray(pbuffer))[j*numtracks+k].byte4;
	 
            chnvol=-1;
            operands=byte4;
            switch (byte3){
          /*1*/ case 0x1 : effekt = portamento_down;break;/* rs_portd-p   */
          /*2*/ case 0x2 : effekt = portamento_up  ;break;/* rs_portu-p   */
          /*a*/ case 0xa : effekt = oktarpg2       ;break;/* rs_arp-p     *//*down(arg1) org up(arg2) org*/
          /*b*/ case 0xb : effekt = oktarpg1       ;break;/* rs_arp2-p    *//*org up(arg1) org down(arg2) org*/
          /*c*/ case 0xc : effekt = arpeggio       ;break;/* rs_arp3-p    *//*up(arg1) up(arg2) org*/
          /*d*/ case 0xd : effekt = oktslddwn      ;break;/* kontinuierliches slide down halbtonschritte*/
          /*f*/ case 0xf : effekt=enhanced;
          /*h*/case 0x11 : effekt = oktsld1up      ;break;/*slide up   once - sofort*/
          /*l*/case 0x15 : effekt = oktsld1dwn     ;break;/*slide down once - sofort*/
          /*o*/case 0x16 : effekt = oktoldvol      ;break;/*set old volume - bei setvol altes vol merken*/
          /*p*/case 0x19 : {  effekt=positionjump; operands=(operands and 0xf)+(operands shr 4)*10+1;break; }
          /*r*/case 0x1b : { effekt=enhanced;operands=(retrignote shl 4)+(operands and 0xf);break; }
          /*s*/case 0x1c : effekt = setspeed;break;       /* p-rs_cspeed  */
          /*u*/case 0x1e : effekt = oktsldup;break;       /*slide up continuierlich*/
          /*v*/case 0x1f : {                     /* rs_volume-p  */
	    if ( operands <= 0x40 ) effekt = setvolume
                     else if ( operands<0x50 ) { effekt=volumeslide;operands=operands-0x40;}
                     else if ( operands<0x60 ) { effekt=enhanced;operands=(finevoldwn << 4)+(operands-0x50);}
                     else if ( operands<0x70 ) { effekt=volumeslide;operands=(operands - 0x60) << 4;}
                     else if ( operands<0x80 ) { effekt=enhanced;operands=(finevolup << 4)+(operands-0x70);}
	    }
	    /*w,x,y,z -nichts*/
	    default: { effekt=noeffekt;operands=0;break;}
            } //switch
            
	    if ( byte1!=0 ){
              ton        = pitchtable[byte1+12];
              instrument = byte2+1;
            }
            if ( (effekt!=noeffekt)or(operands!=0)||(ton!=0)||(instrument!=0)) reached=true;
          }//with
          if ( reached ) trackwrite(1,pattlen) else trackwrite(1,0);
        }
      } else trackwrite(numtracks,0);
    } else { error=id_nomodfile;free(pbuffer);exit;}
  }
  /*lesen der dummy-pattern*/
  do{
    f.read(pbuffer,sizeof(toktsign));
    if ( poktsign(pbuffer)^.b4sign=='pbod'
    ) seek(f,filepos(f)+swaplong(poktsign(pbuffer)^.structsize))
    else if ( poktsign(pbuffer)^.b4sign=='sbod' ) break
    else { error=id_nomodfile;free(pbuffer);exit;}
  }while ((poktsign(pbuffer)->b4sign=='sbod')||(eof(f)));
  //until (poktsign(pbuffer)^.b4sign=='sbod')||(eof(f));
  
  f.seekg(filepos(f)-8);
  /*loading the instruments*/
  i=0;
  do{
    i++;
    if ( instruments[i].iend>0 )
    {
      f.read(pbuffer,sizeof(toktsign));
      /*if ( f.gcount()==0 ) break;*/
      poktsign(pbuffer)->structsize=swaplong(poktsign(pbuffer)->structsize);
      if ( poktsign(pbuffer)->b4sign=='sbod' ) 
	//with instruments[i] do
      {
	char *const& name=instruments[i].name;
	int32& offset    =instruments[i].offset;
	int32& iend      =instruments[i].iend;
	int32& loopstart =instruments[i].loopstart;
	int32& loopend   =instruments[i].loopend;
	byte& volume     =instruments[i].volume;
	byte& finetune   =instruments[i].finetune;
	byte& bits       =instruments[i].bits;
	word& tuning     =instruments[i].tuning;  

        iend=poktsign(pbuffer)->structsize;
        offset=songmemofs;
        unilong=0;
	// if ( iend>65520 ) bufsize=65520 else bufsize=loword(iend);
        //repeat
          f.read(pbuffer,iend);
          if ( result=f.tellg()>0 )
          {
            if ( (bits && (0x1f==7)) && (!one_8)) 
	      songmemwrite(pbuffer,result,4)
            else songmemwrite(pbuffer,result,0);
          }
          //unilong=unilong+longint(result);
          //if ( iend-unilong<longint(bufsize) ) bufsize=iend-unilong;
	  //until (unilong==iend)or(result==0);
	  //iend=unilong;
        if ( iend>0 )
        {
          if ( volume>64 ) volume=64;
          if ( loopend>iend ) loopend=iend;
          if ( loopstart>iend ) loopstart=0;
          if ( loopend-loopstart<4 ) { loopstart=0;loopend=0; }
          iend+=offset;
          if ( loopend>0 )
          {
            loopend+=offset;
            loopstart+=offset;
          }
        } else offset=0;
      } else break;
    }
  } while (!f.eof);//until eof(f);
    free(pbuffer);
}



